
#include <stm32f10x.h>              /* STM32F10x Library */


#include "w6100.h"						/* W5100 Register definition */
#include "w6100_init.h"
#include "SPI.h"
#include "socket.h"
#include "ftpc.h"

#ifndef DATA_BUF_SIZE
	#define DATA_BUF_SIZE			2048
#endif
#define AS_IPV4 2
#define AS_IPV6 23
#define AS_IPDUAL 11
extern  uint8_t msg_c;
//static uint8_t curr_state[8] = {0,};
//static uint8_t sock_state[8] = {0,};
char* msg_v4 = "IPv4 mode";
char* msg_v6 = "IPv6 mode";
char* msg_dual = "Dual IP mode";

int32_t loopback_udps(uint8_t sn, uint8_t* buf, uint16_t port, uint8_t loopback_mode);
int32_t loopback_tcps(uint8_t sn, uint8_t* buf, uint16_t port, uint8_t loopback_mode);
int32_t loopback_tcpc(uint8_t sn, uint8_t* buf, uint8_t* destip, uint16_t destport, uint8_t loopback_mode);
uint8_t buff[2048];
uint8_t buff0[2048];
uint8_t IP_TYPE;

/******************************************************************************/
/*******************           Main function             **********************/
/******************************************************************************/
int main(void)
{
	
  uint8_t FTP_destip4[4]={192,168,1,57};
							
  
  /*init system*/							  
	Systick_Init(72);	
	/*init usart*/
	USART1_Init(); 		
	printf("usart init ok\r\n");
	/*init gpio spi fsmc*/
	GPIO_Configuration();		
#if _WIZCHIP_IO_MODE_ & _WIZCHIP_IO_MODE_BUS_INDIR_
	
	 FSMC_Init();

#else	
	WIZ_SPI_Init();
	
#endif
	
	/*reset w6100*/
	Reset_W6100();
	/*init network*/
	Set_Network();														
 /*init ftp client*/
  ftpc_init(FTP_destip4, 21, AS_IPV4);

    while(1)
    {
        ftpc_run(buff0);
   }
	
}


